#sccs	"@(#)adminbin:Fformat10.sh	1.1"
#                                                                Fformat10.sh
# PURPOSE: Format a 10 sector/track Floppy disk using the iv function
# CALLED BY: Floppy object file in /usr/lib/ua
# REQUIRED FILES: /etc/iv, /usr/lib/iv/FD10 files
# -------------------------------------------------------------------------

ERROR1="You have a disk mounted already!\n\nPossible reasons: you have another Floppy window opened or you did a 'mount' on the system.Please dismount the floppy disk by closing the 'Floppydisk' window or issue a 'dismount -f' in the 'Unix' window before attempting this operation."

LOCKFILE=/tmp/FinUse.lock
ERRINUSE="The floppy disk is already in use by another application.  Please wait for the disk to finish before starting again."

MUSTBECON="You may not format floppy disks from a remote terminal."

TERMCAP=
export TERMCAP
umask 022

##  LIMIT FORMATTING TO CONSOLE USERS

TTY=`tty`
expr "$TTY" : "/dev/w." > /dev/null 2>&1
if [ $? != 0 ]
then
	message -u "$MUSTBECON"
	exit 1
fi

##  CHECK THAT FLOPPY IS NOT IN USE BY OTHER OPERATIONS.

if [ -s $LOCKFILE ]
then
	sh /usr/bin/Funlock.sh
	if [ $? != 0 ]
	then
		message -u "$ERRINUSE"
		exit
	fi
fi

##  CHECK THAT THE FLOPPY IS NOT MOUNTED.

DEVNUM=`mount | wc -l | cut -c7-7` 
if [ "$DEVNUM" != "1" ] 
then
	clear
       	message -cu $ERROR1
  	exit
fi

message -cu "Please insert the floppy disk for formatting.\n\nWARNING: this will erase whatever is currently on the floppy disk!"
if [ $? != "0" ]
then
	exit
fi

clear
echo "\n\n\n\n\n         Floppy format in progress\n\n\n\n"

echo "$$ Fformat10.sh" > $LOCKFILE

GO=1
while [ "$GO" = 1 ]
do
	GO=0
	iv -i /dev/rfp020 /usr/lib/iv/FD10nl > /dev/null 2>&1
	if [ "$?" != "0" ]
	then
		clear
		message -cu "Cannot format floppy disk.  Possible reasons include: disk has silver write-protect tab on it (remove tab); disk is not inserted or is inserted improperly; latch is not closed or disk is bad. Please check floppy disk."
		if [ $? != "0" ]
		then 
			dismount -f > /dev/null 2>&1
			rm -f $LOCKFILE
			exit
		fi
		GO=1
	else
		mkfs /dev/rfp021 > /dev/null 2>&1
		dismount -f > /dev/null 2>&1
		clear
		message -iu "The floppy diskette is now formatted.\n\nPlease press Enter to continue."
	fi
done
rm -f $LOCKFILE
