#sccs	"@(#)adminbin:Restore.sh	1.8"
#                                                                Restore.sh
# PURPOSE: Restore (cpio) files from floppy disk
# CALLED BY: Administration
# REQUIRED FILES: Restore.menu Restore.form
# ------------------------------------------------------------------------
#

ERROR1="You have a disk mounted already!\n\nPossible reasons: you have another Floppy window opened or you did a 'mount' on the system.  Please dismount the floppy disk by closing the 'Floppydisk' window or issue a 'dismount -f' in the 'Unix' window before attempting this operation."

LOCKFILE=/tmp/FinUse.lock
ERRINUSE="The floppy disk is already in use by another application.  Please wait for the disk to finish before starting again."


TERMCAP=
export TERMCAP
umask 022

trap "" 2

##  CHECK THAT FLOPPY IS NOT IN USE BY OTHER OPERATIONS.

if [ -s $LOCKFILE ]
then
	sh /usr/bin/Funlock.sh
	if [ $? != 0 ]
	then
		message -u "$ERRINUSE"
		exit
	fi
fi

##  CHECK THAT THE FLOPPY IS NOT MOUNTED.

DEVNUM=`mount | wc -l | cut -c7-7`
if [ "$DEVNUM" != "1" ]
then
	clear
	message -cu "$ERROR1"
	exit
fi

while true
do
	RET=`shform -u $UA/Restore.menu`
	err=$?
	if [ "$err" != "0" ] 
	then
		message "Error $err in menu: Restore.menu"
		exit
	fi
	eval set $RET ; RET1=$1 ; RET2=$2 ; SLCTN=$2
	eval set $RET2 ; RET2=$1 ; RET3=$2 ; RET4=$3; RET5=$4
	if test "$RET1" = Cancel
	then
		exit
	elif test "$RET1" = Enter
	then
		break
	elif test "$RET1" = Help
	then
		case $SLCTN in
		  "RESTORE All" )
			HELP="Restore All" ;;
		  "RESTORE by UNIX Name" )
			HELP="Restore by Name" ;;
		  "SHOW and RESTORE Folders" )
			HELP="Restore Folders" ;;
		  "SHOW and RESTORE Files" )
			HELP="Restore Files" ;;
		  *)	HELP="Restore" ;;
		esac
		/usr/bin/uahelp -h $UA/admin.hlp -t "$HELP"
		clear
	fi
done

YN=Yes

while true
do
	clear
	export YN
	RET=`shform -u $UA/Restyn.form`

	err=$?
	uflag=""
	if [ "$err" != "0" ] 
	then
		message "Error $err in menu: Restyn.menu"
		exit
	fi
	eval set $RET
	YN="$2"
	SRET1=$1
	if test "$SRET1" = Cancel
	then
		exit
	elif test "$SRET1" = Enter
	then
		break
	elif test "$SRET1" = Help
	then
		clear
		/usr/bin/uahelp -h $UA/admin.hlp -t "Uncond Overwrite"
	fi
done

	if test "$YN" = Yes
	then
		uflag=u;
	fi
	         
while true
do

FINISHED=false
OUTOFSPACE=false
ABORT=false

while true
do
	clear
	message -cu "Insert floppy to restore from"
	if [ "$?" != "0" ] ; then exit ; fi
# We have prompted user to insert floppy; determine whether it's formatted
	FLOP=`iv -t /dev/rfp020 2>/dev/null | grep Partition`
	if [ "$?" != "0" ] 
	then
		clear
		message -cu "Floppy is either not inserted, is incorrectly inserted, is not formatted or has a hard error."
		if [ "$?" != "0" ] ; then exit ; fi
	else
		break
	fi
done
clear

echo "$$ Restore.sh" > $LOCKFILE

if test "$RET2" = RESTORE 
then
	if
		test "$RET3" = All 
	then
		clear
		newwind
		clear
		echo "\n\n\n\n\n                         Restore in progress\n\n"
		trap "" 2
		cpio -iBdc$uflag < /dev/rfp021 2>/tmp/cplog$$
		err=$?
		trap 2
		if [ "`grep \"Out of phase\" /tmp/cplog$$`" ]
		then
			dismount -f > /dev/null 2>&1
			clear
			message -u "The floppy diskette you inserted is either not the correct floppy, or you inserted it in the wrong order.  Please start over again from the first floppy.  If this problem reoccurs at the same floppy, the disk may be bad."
		elif [ "`grep \"annot create\" /tmp/cplog$$`" ]
		then
			clear
			OUTOFSPACE=true
			break
		elif [ "$err" = "4" ] 
		then
			clear
			ABORT=true
			break
		elif [ "$err" != "0" ] 
		then
			dismount -f > /dev/null 2>&1
			clear
			message -u "There was an error in the restore.  Please start over again from the first floppy.  If this problem reoccurs at the same floppy, the disk may be bad.\n"
		else
			clear
			FINISHED=true
			break
		fi
	elif
		test "$RET3" = by 
	then
		while true
		do
#		loop until user hits Enter or Cancel
			clear
			SRET=`shform -u $UA/Restore.form`
			err=$?
			if [ "$err" != "0" ] 
			then
				message "Error $err in form: Restore.form"
				rm -f $LOCKFILE
				exit
			fi
			set $SRET
			eval SRET1=$1
			if test "$SRET1" = Enter
			then
				shift
				break
			elif test "$SRET1" = Cancel
			then
				dismount -f > /dev/null 2>&1
				rm -f $LOCKFILE
				exit
			elif test "$SRET1" = Help
			then
				/usr/bin/uahelp -h $UA/admin.hlp -t "Restore by Name"
			fi
		done
		PATTERNS=
		while test $# != 0
		do
			eval fnm=$1
			if test "$fnm" = ""
			then
				break
			fi
			eval fty=$2
			if
				test "$fty" = Folder
			then
				FLDTAG="/* $fnm"
			else
				FLDTAG=
			fi
			PATTERNS="$PATTERNS $fnm$FLDTAG"
#			echo "PATTERNS=$PATTERNS"
			shift
			shift
		done
		if test "$PATTERNS" = ""
		then
			clear
			message -u "No selections were made, therefore no restore was performed"
		else
			clear
			newwind
			clear
			echo "\n\n\n\n\n                         Restore in progress\n\n"
			trap "" 2
			cpio -iBdc$uflag $PATTERNS < /dev/rfp021 2>/tmp/cplog$$
			err=$?
			trap 2
			if [ "`grep \"Out of phase\" /tmp/cplog$$`" ]
			then
				dismount -f > /dev/null 2>&1
				clear
				message -u "The floppy diskette you inserted is either not the correct floppy, or you inserted it in the wrong order.  Please start over again from the first floppy.  If this problem reoccurs at the same floppy, the disk may be bad.\n"
			elif [ "`grep \"annot create\" /tmp/cplog$$`" ]
			then
				clear
				OUTOFSPACE=true
				break
			elif [ "$err" = "4" ] 
			then
				clear
				ABORT=true
				break
			elif [ "$err" != "0" ] 
			then
				dismount -f > /dev/null 2>&1
				clear
				message -u "There was an error in the restore.  Please start over again from the first floppy.  If this problem reoccurs at the same floppy, the disk may be bad.\n"
			else
				clear
				FINISHED=true
				break
			fi
		fi
	fi
elif
	test "$RET2" = SHOW
then
	if
		test "$RET5" = Folders 
	then
		FLFD=folder
#		in cpio -iBtvc output, "40" indicates a directory
		PARM=40
		FLDTAG=/*
	elif
		test "$RET5" = Files
	then
		FLFD=file
#		in cpio -iBtvc output, "10" indicates a file
		PARM=10
		FLDTAG=
	fi
#	construct menu
	echo "Menu = SHOW Contents--"$FLFD > rslist.menu
	echo "Prompt = Select "$FLFD"(s), press Enter" >> rslist.menu
	echo "Multiple" >> rslist.menu
	clear
	newwind
	clear
	echo "\n\n\n\n\n\n                      Reading floppy diskette."
	echo "                      Please do not remove.\n\n\n\n"
	cpio -ivtBc < /dev/rfp021  2>/tmp/cplog$$ > /tmp/cplst$$
	err=$?
	cut -c1-2,44-121 /tmp/cplst$$ | grep "^$PARM" | sed  "s/"$PARM"/Name = /p" >> rslist.menu 
	rm -f /tmp/cplst$$
	if [ "`grep \"Out of phase\" /tmp/cplog$$`" ]
	then
		dismount -f > /dev/null 2>&1
		clear
		message -u "The floppy diskette you inserted is either not the correct floppy, or you inserted it in the wrong order.  Please start over again from the first floppy.  If this problem reoccurs at the same floppy, the disk may be bad.\n"
	elif [ "`grep \"annot create\" /tmp/cplog$$`" ]
	then
		clear
		OUTOFSPACE=true
		break
	elif [ "$err" = "4" ] 
	then
		clear
		ABORT=true
		break
	elif [ "$err" != "0" ] 
	then
		dismount -f > /dev/null 2>&1
		clear
		message -u "There was an error in reading the floppy diskette. Please start over again from the first floppy.  If this problem reoccurs at the same floppy, the disk may be bad.\n" 
	else
		PATTERNS=
		while true
		do
#	loop until user hits Enter or Cancel
			clear
			SRET=`shform -u rslist.menu`
			err=$?
			if [ "$err" != "0" ] 
			then
				message "Error $err in menu: rslist.menu"
				rm -f $LOCKFILE
				exit
			fi
			set $SRET ; eval SRET1=$1
			if test "$SRET1" = Enter
			then
				break
			elif test "$SRET1" = Cancel
			then
				rm -f rslist.menu
				dismount -f > /dev/null 2>&1
				rm -f $LOCKFILE
				exit
			elif test "$SRET1" = Help
			then
			       /usr/bin/uahelp -h $UA/admin.hlp -t "Restore $RET5"
			fi
		done
		shift
		while test $# != 0
		do
			eval fnm=$1
			PATTERNS="$PATTERNS $fnm$FLDTAG"
			if [ -n "$FLDTAG" ]
			then
				PATTERNS="$PATTERNS $fnm"
			fi
			shift
		done
	#	make sure PATTERNS isn't empty, or the whole cpio archive will be restored
		if test "$PATTERNS" = ""
		then
			clear
			message  -iu "No selections were made, therefore no restore was performed."
		else
			clear
			message -iu "If you are restoring from more than one floppy diskette, please reinsert the first diskette.\n\nPress Enter to continue"
			if [ $? != 0 ]
			then
				rm -f rslist.menu
				dismount -f > /dev/null 2>&1
				rm -f $LOCKFILE
				exit
			fi
			clear
			rm -f rslist.menu
			newwind
			clear
			echo "\n\n\n\n\n                         Restore in progress\n\n"
			trap "" 2
			cpio -iBdc$uflag $PATTERNS < /dev/rfp021 2>/tmp/cplog$$ 
			err=$?
			trap 2
			if [ "`grep \"Out of phase\" /tmp/cplog$$`" ]
			then
				dismount -f > /dev/null 2>&1
				clear
				message -u "The floppy diskette you inserted is either not the correct floppy, or you inserted it in the wrong order.  Please start over again from the first floppy.  If this problem reoccurs at the same floppy, the disk may be bad.\n"
			elif [ "`grep \"annot create\" /tmp/cplog$$`" ]
			then
				clear
				OUTOFSPACE=true
				break
			elif [ "$err" = "4" ] 
			then
				clear
				ABORT=true
				break
			elif [ "$err" != "0" ] 
			then
				dismount -f > /dev/null 2>&1
				clear
				message -u "There was an error in the restore.  Please start over again from the first floppy.  If this problem reoccurs at the same floppy, the disk may be bad.\n"
			else
				clear
				FINISHED=true
				break
			fi
		fi
	fi
fi
done
rm -f $LOCKFILE
rm -f /tmp/cplog$$
if $FINISHED
then
	message -iu "The restore is now finished.\n\nPlease press Enter to continue."
elif $OUTOFSPACE
then
	message -u "Your system is out of space.  Please remove some files and try again."
elif $ABORT
then
	message -u "This restore operation has been canceled."
fi
