#sccs	"@(#)adminbin:Uninstall.sh	1.4"

#                                                              Uninstall.sh
# PURPOSE: Delete installed software
# CALLED BY: /usr/lib/ua/Software
# REQUIRED FILES: Uninstall.menu
# MODIFIED FILES: /usr/installed/CONTENTS and the uninstall script.
# ------------------------------------------------------------------------

ERROR1="An error has been encountered in the menu file Uninstall.menu\n  Please notify AT&T User Support.  Thank you."
ERROR2="The command provided was not recognized.\nPlease use Enter, Cancel, or a defined function key."
ERROR3="A reference file could not be found for this tool.  It must be removed using UNIX System tools from the UNIX Shell."
ERROR4="No uninstall program could be found for this tool.  It must be removed using UNIX System tools from the UNIX Shell."
ERROR5="There are currently no software applications installed."


TERMCAP=
export TERMCAP
umask 022
CONTENTS=/usr/installed/CONTENTS
INDIR=/usr/installed

# Trap the delete key
trap "" 2

if [ \( ! -r $CONTENTS \) -o \( ! -s $CONTENTS \) ]
then
	clear
	message -u $ERROR5
	exit
fi

# Execute the menu

while true
do
RET=`shform -u $UA/Uninstall.menu`
if [ "$?" != "0" ]
then
	message $ERROR5
	exit
fi

set $RET

# The shell variable $1 contains the string describing the action key
# The remaining variables contain the name of the package to be deleted

case $1 in
# Executable code for the "enter" option follows here
	\'Enter\')
shift
eval NAME=$*

#	Added by DLM to conform removal and give the
#		user a chance to bail out

message -c "Do you wish to remove the \"$NAME\" package?"
RC=$?
if [ $RC -ne 0 ]
then
	message -i  "You have cancelled the removal of $NAME\n\n\tHit Enter to continue"
	exit
fi
eval ` grep "^[0-9]* $NAME$" $CONTENTS | awk ' { print "KEY="$1 } '  `

if [ ! "$KEY" ]
then
	message $ERROR3
	exit
fi

export KEY NAME

UNFILE=${INDIR}/${KEY}.un
if [ -r "$UNFILE" ]
then
# THIS LINE ADDED BY FAH BECAUSE SOME Remove files were not executable
	chmod +x $UNFILE
	clear
	newwind
	clear
	$UNFILE
	if [ "$?" != "64" ]
	  then
	grep -v "^[0-9]* $NAME$" $CONTENTS > /tmp/$$
	mv /tmp/$$ $CONTENTS
	grep -v "^Name=$NAME$" $UA/Uninstall.menu > /tmp/Un$$
	grep -v "^Name=$NAME$" $UA/Showsoft.menu > /tmp/Sh$$
	mv /tmp/Un$$ $UA/Uninstall.menu
	mv /tmp/Sh$$ $UA/Showsoft.menu
	chmod +x $UNFILE
	rm $UNFILE
	clear
	message -iu "The $NAME package is now removed.\n\n  Please press Enter to continue\n"
	I=`ps -e | grep ua | cut -c1-6`
	for i in $I
	do
		kill -16 $i
	done
	fi
	exit
else
	clear
	message -u $ERROR4
	clear
fi
	;;

# This is the Exit code if command is cancelled
	\'Cancel\')
	exit
	;;

# This is the Help code
	\'Help\')
	/usr/bin/uahelp -h $UA/admin.hlp -t "Remove Software"
	;;

# Unrecognizable return from action key
	*)
	clear
	message -u "$ERROR2"
	clear	
	;;

# End of main case based on the action key
esac
clear
done
# ========================================================================
